#!/bin/bash
vendor_id="1172"
device_id="abba"
module="rw_bar"
device="rw_bar"
mode="664"

echo "Now Loading $device for $vendor_id:$device_id"

# Group: since distributions do it differently, look for wheel or use staff
if grep '^staff:' /etc/group > /dev/null; then
    group="staff"
else
    group="wheel"
fi

# remove stale nodes
rm -f /dev/${device}? 


used_bars=`lspci -v -d $vendor_id:$device_id | grep Memory | wc -l`

# invoke insmod with all arguments we got
# and use a pathname, as newer modutils don't look in . by default
/sbin/insmod -f ./$module.o "used_bars=$used_bars" $* || exit 1

major=`cat /proc/devices | awk "\\$2==\"$module\" {print \\$1}"`
for (( I=0; $used_bars-$I; I=$I+1 )); do
mknod /dev/${device}$I c $major $I
chgrp $group /dev/${device}$I
chmod $mode  /dev/${device}$I
done;

